/*
   A program illustrating exhausting memory with malloc to see what
   happens.
*/

#include <stdlib.h>
#include <stdio.h>
#include <limits.h>
#include <errno.h>
#include <string.h>

int main(void)
{
    char *s;
    unsigned long request, total;

    request = 1;
    total = 0;
    while ((s = malloc(request)) != NULL) {
	printf("Got %lu byte(s)\n", request);
	total += request;
	request <<= 1;
    }
    printf("Malloc returned NULL.  Error string: %s\n", strerror(errno));
    printf("Total memory obtained: %lu\n", total);
    printf("             Max uint: %lu\n", UINT_MAX);

    return 0;
}
