/*
   A simple program to illustrate that malloc does not initialize
   memory.
*/

#include <stdlib.h>
#include <stdio.h>

int
main(void)
{
    int *ptr;
    const int N = 10;
    int i;

    /* fill data */
    ptr = malloc(N * sizeof(*ptr));
    if (ptr == NULL) {
        perror("malloc failed");
        exit(1);
    }

    for (i=0; i<N; i++) {
        ptr[i] = 0xDEADBEEF;
    }

    free(ptr);

    /* look at data */
    printf("malloc:\n");
    ptr = malloc(N * sizeof(*ptr));
    if (ptr == NULL) {
        perror("malloc failed");
        exit(1);
    }
    for (i=0; i<N; i++) {
        printf("%d %08x\n", i, ptr[i]);
    }

    free(ptr);

    printf("\ncalloc:\n");
    /* look at data, this time with calloc */
    ptr = calloc(N, sizeof(*ptr));
    if (ptr == NULL) {
        perror("malloc failed");
        exit(1);
    }
    for (i=0; i<N; i++) {
        printf("%d %08x\n", i, ptr[i]);
    }
    return 0;
}
