/* A simple program to ``square'' a string. */

#include <stdio.h>
#include <err.h>
#include <string.h>
#include <stdlib.h>

void
square_print(unsigned int len, char *cp)
{
    unsigned int i, j;

    if (len * len < len) /* overflow */
        errx(1, "Error in square_print: len (%d) overflows", len);

    for (i=0; i<len; i++) {
	for (j=0; j<len; j++)
	    putchar(cp[i*len + j]);
	printf("\n");
    }
}

int main(int argc, char *argv[])
{
    unsigned int i, j, length;
    char *cp;

    if (argc != 2)
        errx(1, "Usage: %s string", argv[0]);

    length = strlen(argv[1]);
    if (length * length < length) /* overflow */
        errx(1, "Error: string length (%d) too large", length);

    cp = malloc(length * length);

    for (i=0; i<length; i++) 
	for (j=0; j<length; j++) 
	    cp[i*length + j] = argv[1][(j + i) % length];

    square_print(length, cp);

    return 0;
}
