#include <fcntl.h>
#include <err.h>
#include <unistd.h>
#include <stdio.h>
#include <iostream>
using namespace std;

int wrapped_open(const char *path, int flags, mode_t mode)
{
    int fd = open(path, flags, mode);

    if (fd == -1)
        throw path;

    return fd;
}

int main(int argc, char *argv[])
{
    const unsigned int bufsize = 20;
    int fd;
    char buf[bufsize];

    if (argc != 2)
        errx(1, "Usage: %s file", argv[0]);

    /* The exception version */
    try {
        fd = wrapped_open(argv[1], O_RDONLY, 0);
    }
    catch (const char *path) {
	cerr << "Caught thrown exception\n";
        err(1, "Open of %s failed", path);
    }
    /* A straight version ignoring errors; uncomment to use. */
    // fd = open(argv[1], O_RDONLY, 0);

    /*
       Here is an old-style error check.  Consider if the read() had
       been several functions down, but we are the level where the error
       needed to be handled.  The code could get messy.
    */
    if (read(fd, buf, bufsize-1) != -1) {
	buf[bufsize-1] = '\0';
        printf("Read: '%s'\n", buf);
    } else {
        err(1, "Read failed");
    }
}
